/*  HSYCO CONTROLLER, EVENTS SCRIPT - FUNCTIONS, version 3.3.1 Build 0114
 *  (c) 2013-2014 Home Systems Consulting S.p.A.
 *
 *  For information, see the Home Systems Consulting web site:
 *  http://www.homesystemsconsulting.com/
 *
/*------------------------------------------------------------*/

var OFF = com.hsyco.user.OFF;
var ON = com.hsyco.user.ON;
var NOCHANGE = com.hsyco.user.NOCHANGE;
var UNKNOWN = com.hsyco.user.UNKNOWN;
var PAUSE = com.hsyco.user.PAUSE;
var PLAY = com.hsyco.user.PLAY;
var MERGED = com.hsyco.user.MERGED;



function cameraRecTrigger(cameraName, source, seconds) {
	if (__run == '1') {
		com.hsyco.user.cameraRecTrigger(cameraName, source, seconds);
	}
}

function cameraRecTriggerFull(cameraName, source, seconds) {
	if (__run == '1') {
		com.hsyco.user.cameraRecTriggerFull(cameraName, source, seconds);
	}
}

function haActiveState() {
	return Boolean(com.hsyco.user.haActiveState());
}

function haActive(active) {
	if (__run == '1') {
		com.hsyco.user.haActive(active);
	}
}

function deviceFunctionGet(name) {
	return Number(com.hsyco.user.deviceFunctionGet(name));
}

function irtransCommand(irId, command) {
	if (__run == '1') {
		return Number(com.hsyco.user.irtransCommand(irId, command));
	} else {
		return 0;
	}
}

function isDaylight() {
	return Boolean(com.hsyco.user.isDaylight());
}

function getNextSunrise(now, withoffset) {
	return Number(com.hsyco.user.getNextSunrise(now, withoffset));
}

function getNextSunset(now, withoffset) {
	return Number(com.hsyco.user.getNextSunset(now, withoffset));
}

function uiClear(session) {
	if (__run == '1') {
		com.hsyco.user.uiClear(session);
	}
}

function uiSessionSet(session, id, attr, value) {
	if (__run == '1') {
		com.hsyco.user.uiSet(session, id, attr, value);
	}
}

function uiSet(id, attr, value) {
	if (__run == '1') {
		com.hsyco.user.uiSet(id, attr, value);
	}
}

function uiSessionGet(session, id, attr) {
	var v = String(com.hsyco.user.uiGet(session, id, attr));
	return (v === null) ? null : String(v);
}

function uiGet(id, attr) {
	var v = String(com.hsyco.user.uiGet(id, attr));
	return (v === null) ? null : String(v);
}

function errorLog(message) {
	if (__run == '1') {
		com.hsyco.user.errorLog(message);
	}
}

function messageLog(message) {
	if (__run == '1') {
		com.hsyco.user.messageLog(message);
	}
}

function fileLog(pathname, message) {
	if (__run == '1') {
		com.hsyco.user.fileLog(pathname, message);
	}
}

function sleep(millis) {
	if (__run == '1') {
		com.hsyco.user.sleep(millis);
	}
}

function cameraCommand(func, action, camera) {
	if (__run == '1') {
		return Number(com.hsyco.user.cameraCommand(func, action, camera));
	} else {
		return 0;
	}
}

function cameraRecMode(cameraName, enabled) {
	if (__run == '1') {
		com.hsyco.user.cameraRecMode(cameraName, enabled);
	}
}

function cameraMode(cameraName, enabled) {
	if (__run == '1') {
		com.hsyco.user.cameraMode(cameraName, enabled);
	}
}

function slimButton(player, button) {
	if (__run == '1') {
		return Number(com.hsyco.user.slimButton(player, button));
	} else {
		return 0;
	}
}

function slimCommand(player, command) {
	if (__run == '1') {
		var v = String(com.hsyco.user.slimCommand(player, command));
		return (v === null) ? null : String(v);
	} else {
		return null;
	}
}

function wakeOnLan(broadcast, address) {
	if (__run == '1') {
		return Number(com.hsyco.user.wakeOnLan(broadcast, address));
	} else {
		return 1;
	}
}

function readComm(portName, len) {
	if (__run == '1') {
		var v = String(com.hsyco.user.readComm(portName, len));
		return (v === null) ? null : String(v);
	} else {
		return null;
	}
}

function writeComm(portName, data) {
	if (__run == '1') {
		return Number(com.hsyco.user.writeComm(portName, data));
	} else {
		return 0;
	}
}

function closeComm(portName) {
	if (__run == '1') {
		com.hsyco.user.closeComm(portName);
	}
}

function dmxSet(channel, state) {
	if (__run == '1') {
		return Number(com.hsyco.user.dmxSet(channel, state));
	} else {
		return 0;
	}
}

function dmxOn(channel) {
	if (__run == '1') {
		return Number(com.hsyco.user.dmxOn(channel));
	} else {
		return 0;
	}
}

function dmxOff(channel) {
	if (__run == '1') {
		return Number(com.hsyco.user.dmxOff(channel));
	} else {
		return 0;
	}
}

function dmxMerge(fromChannel, toChannel, merge) {
	if (__run == '1') {
		return Number(com.hsyco.user.dmxMerge(fromChannel, toChannel, merge));
	} else {
		return 0;
	}
}

function dmxGet(channel) {
	return Number(com.hsyco.user.dmxGet(channel));
}

function ioServersStop(name) {
	if (__run == '1') {
		return Number(com.hsyco.user.ioServersStop(name));
	} else {
		return -1;
	}
}

function ioServersRestart(name) {
	if (__run == '1') {
		return Number(com.hsyco.user.ioServersRestart(name));
	} else {
		return -1;
	}
}

function ioSet(id, value) {
	if (__run == '1') {
		com.hsyco.user.ioSet(id, value);
	}
}

function ioGet(id) {
	var v = String(com.hsyco.user.ioGet(id));
	return (v === null) ? null : String(v);
}

function schedulerRegister(groupname, schedulename, interval) {
	if (__run == '1') {
		com.hsyco.user.schedulerRegister(groupname, schedulename, interval);
	}
}

function schedulerRemove(groupname, schedulename) {
	if (__run == '1') {
		com.hsyco.user.schedulerRemove(groupname, schedulename);
	}
}

function powerSet(power) {
	if (__run == '1') {
		com.hsyco.user.powerSet(power);
	}
}

function varGet(name) {
	var v = com.hsyco.user.varGet(name);
	return (v === null) ? null : String(v);
}

function varSet(name, value) {
	if (__run == '1') {
		com.hsyco.user.varSet(name, value);
	}
}

function programTimerSet(name, seconds) {
	if (__run == '1') {
		com.hsyco.user.programTimerSet(name, seconds);
	}
}

function programTimerClear(name) {
	if (__run == '1') {
		com.hsyco.user.programTimerClear(name);
	}
}

function programTimerReset(name, seconds) {
	if (__run == '1') {
		com.hsyco.user.programTimerReset(name, seconds);
	}
}

function programTimerRepeat(name, seconds) {
	if (__run == '1') {
		com.hsyco.user.programTimerRepeat(name, seconds);
	}
}

function modbusReadCoils(name, unit, address, quantity) {
	if (__run == '1') {
		var pdu = com.hsyco.user.modbusReadCoils(name, unit, address, quantity);
		if (pdu == null) {
			return null;
		} else {
			var pdua = new Array(pdu.length);
			for (i = 0; i < pdu.length; i++) {
				pdua[i] = (pdu[i] >= 0) ? pdu[i] : 256 + pdu[i];
			}
			return pdua;
		}
	} else {
		return null;
	}
}

function modbusReadDiscreteInputs(name, unit, address, quantity) {
	if (__run == '1') {
		var pdu = com.hsyco.user.modbusReadDiscreteInputs(name, unit, address, quantity);
		if (pdu == null) {
			return null;
		} else {
			var pdua = new Array(pdu.length);
			for (i = 0; i < pdu.length; i++) {
				pdua[i] = (pdu[i] >= 0) ? pdu[i] : 256 + pdu[i];
			}
			return pdua;
		}
	} else {
		return null;
	}
}

function modbusReadHoldingRegisters(name, unit, address, quantity) {
	if (__run == '1') {
		var pdu = com.hsyco.user.modbusReadHoldingRegisters(name, unit, address, quantity);
		if (pdu == null) {
			return null;
		} else {
			var pdua = new Array(pdu.length);
			for (i = 0; i < pdu.length; i++) {
				pdua[i] = (pdu[i] >= 0) ? pdu[i] : 256 + pdu[i];
			}
			return pdua;
		}
	} else {
		return null;
	}
}

function modbusReadInputRegisters(name, unit, address, quantity) {
	if (__run == '1') {
		var pdu = com.hsyco.user.modbusReadInputRegisters(name, unit, address, quantity);
		if (pdu == null) {
			return null;
		} else {
			var pdua = new Array(pdu.length);
			for (i = 0; i < pdu.length; i++) {
				pdua[i] = (pdu[i] >= 0) ? pdu[i] : 256 + pdu[i];
			}
			return pdua;
		}
	} else {
		return null;
	}
}

function modbusWriteSingleCoil(name, unit, address, value) {
	if (__run == '1') {
		var pdu = com.hsyco.user.modbusWriteSingleCoil(name, unit, address, value);
		if (pdu == null) {
			return null;
		} else {
			var pdua = new Array(pdu.length);
			for (i = 0; i < pdu.length; i++) {
				pdua[i] = (pdu[i] >= 0) ? pdu[i] : 256 + pdu[i];
			}
			return pdua;
		}
	} else {
		return null;
	}
}

function modbusWriteSingleRegister(name, unit, address, bytes) {
	if (__run == '1') {
		for (i = 0; i < bytes.length; i++) {
			if (bytes[i] > 127) {
				bytes[i] -= 256;
			}
		}
		var pdu = com.hsyco.user.modbusWriteSingleRegister(name, unit, address, bytes);
		if (pdu == null) {
			return null;
		} else {
			var pdua = new Array(pdu.length);
			for (i = 0; i < pdu.length; i++) {
				pdua[i] = (pdu[i] >= 0) ? pdu[i] : 256 + pdu[i];
			}
			return pdua;
		}
	} else {
		return null;
	}
}

function modbusWriteMultipleCoils(name, unit, address, coils, bytes) {
	if (__run == '1') {
		for (i = 0; i < bytes.length; i++) {
			if (bytes[i] > 127) {
				bytes[i] -= 256;
			}
		}
		var pdu = com.hsyco.user.modbusWriteMultipleCoils(name, unit, address, coils, bytes);
		if (pdu == null) {
			return null;
		} else {
			var pdua = new Array(pdu.length);
			for (i = 0; i < pdu.length; i++) {
				pdua[i] = (pdu[i] >= 0) ? pdu[i] : 256 + pdu[i];
			}
			return pdua;
		}
	} else {
		return null;
	}
}

function modbusWriteMultipleRegisters(name, unit, address, bytes) {
	if (__run == '1') {
		for (i = 0; i < bytes.length; i++) {
			if (bytes[i] > 127) {
				bytes[i] -= 256;
			}
		}
		var pdu = com.hsyco.user.modbusWriteMultipleRegisters(name, unit, address, bytes);
		if (pdu == null) {
			return null;
		} else {
			var pdua = new Array(pdu.length);
			for (i = 0; i < pdu.length; i++) {
				pdua[i] = (pdu[i] >= 0) ? pdu[i] : 256 + pdu[i];
			}
			return pdua;
		}
	} else {
		return null;
	}
}

function modbusWriteMaskRegister(name, unit, address, mask, bytes) {
	if (__run == '1') {
		for (i = 0; i < bytes.length; i++) {
			if (bytes[i] > 127) {
				bytes[i] -= 256;
			}
		}
		var pdu = com.hsyco.user.modbusWriteMaskRegister(name, unit, address, mask, bytes);
		if (pdu == null) {
			return null;
		} else {
			var pdua = new Array(pdu.length);
			for (i = 0; i < pdu.length; i++) {
				pdua[i] = (pdu[i] >= 0) ? pdu[i] : 256 + pdu[i];
			}
			return pdua;
		}
	} else {
		return null;
	}
}

function modbusReadWriteMultipleRegisters(name, unit, readaddress, readquantity, writeaddress, bytes) {
	if (__run == '1') {
		for (i = 0; i < bytes.length; i++) {
			if (bytes[i] > 127) {
				bytes[i] -= 256;
			}
		}
		var pdu = com.hsyco.user.modbusReadWriteMultipleRegisters(name, unit, readaddress, readquantity, writeaddress, bytes);
		if (pdu == null) {
			return null;
		} else {
			var pdua = new Array(pdu.length);
			for (i = 0; i < pdu.length; i++) {
				pdua[i] = (pdu[i] >= 0) ? pdu[i] : 256 + pdu[i];
			}
			return pdua;
		}
	} else {
		return null;
	}
}

function sendMail(to, from, subject, body) {
	if (__run == '1') {
		return Number(com.hsyco.user.sendMailMulti(to, from, subject, body));
	} else {
		return -1;
	}
}

function ping(host, timeout) {
	if (__run == '1') {
		return Boolean(com.hsyco.user.ping(host, timeout));
	} else {
		return false;
	}
}

function leakDetectorClear(name) {
	if (__run == '1') {
		com.hsyco.user.leakDetectorClear(name);
	}
}

function leakDetectorOptions(name, param, value) {
	if (__run == '1') {
		com.hsyco.user.leakDetectorOptions(name, param, value);
	}
}

function leakDetectorUpdate(name, value) {
	if (__run == '1') {
		return Number(com.hsyco.user.leakDetectorUpdate(name, value));
	} else {
		return -1;
	}
}

function dataLoggerOptions(name, param, value) {
	if (__run == '1') {
		return Boolean(com.hsyco.user.dataLoggerOptions(name, param, value));
	} else {
		return false;
	}
}

function dataLoggerUpdate(name, value) {
	if (__run == '1') {
		return Boolean(com.hsyco.user.dataLoggerUpdate(name, value));
	} else {
		return false;
	}
}

function dataLoggerClear(name) {
	if (__run == '1') {
		return Boolean(com.hsyco.user.dataLoggerClear(name));
	} else {
		return false;
	}
}

function dataLoggerSave(type, names, path, timestamp) {
	if (__run == '1') {
		return Boolean(com.hsyco.user.dataLoggerSave(type, names, path, timestamp));
	} else {
		return false;
	}
}

function user(name, param) {
	if (__run == '1') {
		com.hsyco.user.user(name, param);
	}
}

function audioPlayFile(where, file) {
	if (__run == '1') {
		return Number(com.hsyco.user.audioPlay(where, file));
	} else {
		return 0;
	}
}

function audioPlayText(where, voice, text) {
	if (__run == '1') {
		return Number(com.hsyco.user.audioPlay(where, voice, text));
	} else {
		return 0;
	}
}

function dateSet(year, month, day, hour, minute, second) {
	if (__run == '1') {
		return Boolean(com.hsyco.user.dateSet(year, month, day, hour, minute, second));
	} else {
		return false;
	}
}

function urlGet(url, user, password) {
	if (__run == '1') {
		var v = String(com.hsyco.user.urlGet(url, user, password));
		return (v === null) ? null : String(v);
	} else {
		return null;
	}
}

function urlPost(url, contenttype, data, user, password) {
	if (__run == '1') {
		var v = String(com.hsyco.user.urlPost(url, contenttype, data, user, password));
		return (v === null) ? null : String(v);
	} else {
		return null;
	}
}